from ..parser import Parser

DEVICE_NAMES = [
    'desktop',
    'smartphone',
    'tablet',
    'feature phone',
    'console',
    'tv',
    'car browser',
    'smart display',
    'camera',
    'portable media player',
    'phablet',
]

DEVICE_TYPE_DESKTOP = 0
DEVICE_TYPE_SMARTPHONE = 1
DEVICE_TYPE_TABLET = 2
DEVICE_TYPE_FEATURE_PHONE = 3
DEVICE_TYPE_CONSOLE = 4
DEVICE_TYPE_TV = 5  # including set top boxes, blu-ray players
DEVICE_TYPE_CAR_BROWSER = 6
DEVICE_TYPE_SMART_DISPLAY = 7
DEVICE_TYPE_CAMERA = 8
DEVICE_TYPE_PORTABLE_MEDIA_PAYER = 9
DEVICE_TYPE_PHABLET = 10
DEVICE_TYPE_SMART_SPEAKER = 11

DEVICE_TYPES = {
    'desktop': DEVICE_TYPE_DESKTOP,
    'smartphone': DEVICE_TYPE_SMARTPHONE,
    'tablet': DEVICE_TYPE_TABLET,
    'feature phone': DEVICE_TYPE_FEATURE_PHONE,
    'console': DEVICE_TYPE_CONSOLE,
    'tv': DEVICE_TYPE_TV,
    'car browser': DEVICE_TYPE_CAR_BROWSER,
    'smart display': DEVICE_TYPE_SMART_DISPLAY,
    'camera': DEVICE_TYPE_CAMERA,
    'portable media player': DEVICE_TYPE_PORTABLE_MEDIA_PAYER,
    'phablet': DEVICE_TYPE_PHABLET,
    'smart speaker': DEVICE_TYPE_SMART_SPEAKER,
}

MOBILE_DEVICE_TYPES = {
    'camera',
    'feature phone',
    'phablet',
    'portable media player',
    'smartphone',
    'tablet',
}

# Before using a new brand in on of the regex files, it needs to be added here
DEVICE_BRANDS = {
    '3Q': '3Q',
    '4G': '4Good',
    'AE': 'Ace',
    'AA': 'AllCall',
    'AC': 'Acer',
    'A9': 'Advan',
    'AD': 'Advance',
    'A3': 'AGM',
    'AZ': 'Ainol',
    'AI': 'Airness',
    '0A': 'AIS',
    'AW': 'Aiwa',
    'AK': 'Akai',
    '1A': 'Alba',
    'AL': 'Alcatel',
    '4A': 'Aligator',
    'A2': 'Allview',
    '3A': 'AllDocube',
    'A7': 'Allwinner',
    'A1': 'Altech UEC',
    'A5': 'altron',
    'AN': 'Arnova',
    '2A': 'Atom',
    'KN': 'Amazon',
    'AG': 'AMGOO',
    'AO': 'Amoi',
    'AP': 'Apple',
    'AR': 'Archos',
    'AS': 'ARRIS',
    'AB': 'Arian Space',
    'AT': 'Airties',
    'A6': 'Ark',
    'A4': 'Ask',
    'A0': 'ANS',
    'A8': 'Assistant',
    'AU': 'Asus',
    'AH': 'AVH',
    'AV': 'Avvio',
    'AX': 'Audiovox',
    'AY': 'Axxion',
    'AM': 'Azumi Mobile',
    'BB': 'BBK',
    'BE': 'Becker',
    'B5': 'Beeline',
    'BI': 'Bird',
    'BT': 'Bitel',
    'BG': 'BGH',
    'BL': 'Beetel',
    'BP': 'Blaupunkt',
    'B3': 'Bluboo',
    'BF': 'Black Fox',
    'B6': 'BDF',
    'BM': 'Bmobile',
    'BN': 'Barnes & Noble',
    'BO': 'BangOlufsen',
    'BQ': 'BenQ',
    'BS': 'BenQ-Siemens',
    'BU': 'Blu',
    'BD': 'Bluegood',
    'B2': 'Blackview',
    'B4': 'bogo',
    'BW': 'Boway',
    'BZ': 'Bezkam',
    'BX': 'bq',
    'BV': 'Bravis',
    'BR': 'Brondi',
    'B1': 'Bush',
    'CB': 'CUBOT',
    'CF': 'Carrefour',
    'CP': 'Captiva',
    'CS': 'Casio',
    'R4': 'Casper',
    'CA': 'Cat',
    'C9': 'CAGI',
    'CE': 'Celkon',
    'CC': 'ConCorde',
    'C2': 'Changhong',
    '2C': 'Ghong',
    'CH': 'Cherry Mobile',
    '1C': 'Chuwi',
    'L8': 'Clarmin',
    'CK': 'Cricket',
    'C1': 'Crosscall',
    'CL': 'Compal',
    'CN': 'CnM',
    'CM': 'Crius Mea',
    'C3': 'China Mobile',
    'CR': 'CreNova',
    'CT': 'Capitel',
    'CQ': 'Compaq',
    'CO': 'Coolpad',
    'C5': 'Condor',
    'CW': 'Cowon',
    'CU': 'Cube',
    'CY': 'Coby Kyros',
    'C6': 'Comio',
    'C7': 'ComTrade Tesla',
    'C8': 'Concord',
    'CX': 'Crescent',
    'C4': 'Cyrus',
    'CV': 'CVTE',
    'D5': 'Daewoo',
    'DA': 'Danew',
    'DT': 'Datang',
    'D1': 'Datsun',
    'DE': 'Denver',
    'DX': 'DEXP',
    'DW': 'DeWalt',
    'DS': 'Desay',
    'DB': 'Dbtel',
    'DC': 'DoCoMo',
    'DG': 'Dialog',
    'DI': 'Dicam',
    'D4': 'Digi',
    'D3': 'Digicel',
    'DD': 'Digiland',
    'D2': 'Digma',
    'D6': 'Divisat',
    'DL': 'Dell',
    'DN': 'DNS',
    'DM': 'DMM',
    'DO': 'Doogee',
    'DV': 'Doov',
    'DP': 'Dopod',
    'DR': 'Doro',
    'DU': 'Dune HD',
    'EB': 'E-Boda',
    'EA': 'EBEST',
    'EC': 'Ericsson',
    'E7': 'Ergo',
    'ED': 'Energizer',
    'E4': 'Echo Mobiles',
    'ES': 'ECS',
    'E6': 'EE',
    'EI': 'Ezio',
    'EM': 'Eks Mobility',
    'L0': 'Element',
    'EL': 'Elephone',
    'EG': 'Elenberg',
    'EP': 'Easypix',
    'EK': 'EKO',
    'E1': 'Energy Sistem',
    'ER': 'Ericy',
    'EE': 'Essential',
    'EN': 'Eton',
    'E2': 'Essentielb',
    '1E': 'Etuline',
    'ET': 'eTouch',
    'EV': 'Evertek',
    'E3': 'Evolio',
    'EO': 'Evolveo',
    'EX': 'Explay',
    'E0': 'EvroMedia',
    'E5': 'Extrem',
    'EZ': 'Ezze',
    'E8': 'E-tel',
    'E9': 'Evercoss',
    'EU': 'Eurostar',
    'FA': 'Fairphone',
    'FM': 'Famoco',
    'FE': 'Fengxiang',
    'FI': 'FiGO',
    'FL': 'Fly',
    'F1': 'FinePower',
    'FT': 'Freetel',
    'FR': 'Forstar',
    'FO': 'Foxconn',
    'F2': 'FORME',
    'FN': 'FNB',
    'FU': 'Fujitsu',
    'FD': 'Fondi',
    'GT': 'G-TiDE',
    'GM': 'Garmin-Asus',
    'GA': 'Gateway',
    'GD': 'Gemini',
    'GN': 'General Mobile',
    'GE': 'Geotel',
    'GH': 'Ghia',
    'GI': 'Gionee',
    'GG': 'Gigabyte',
    'GS': 'Gigaset',
    'GZ': 'Ginzzu',
    'GC': 'GOCLEVER',
    'G4': 'Globex',
    'GL': 'Goly',
    'GO': 'Google',
    'G1': 'GoMobile',
    'GR': 'Gradiente',
    'GP': 'Grape',
    'GU': 'Grundig',
    'HF': 'Hafury',
    'HA': 'Haier',
    'HS': 'Hasee',
    'HE': 'HannSpree',
    'HI': 'Hisense',
    'HL': 'Hi-Level',
    'H2': 'Highscreen',
    'H1': 'Hoffmann',
    'HM': 'Homtom',
    'HO': 'Hosin',
    'HZ': 'Hoozo',
    'HP': 'HP',
    'HT': 'HTC',
    'HU': 'Huawei',
    'HX': 'Humax',
    'HY': 'Hyrican',
    'HN': 'Hyundai',
    'IA': 'Ikea',
    'IB': 'iBall',
    'IJ': 'i-Joy',
    'IY': 'iBerry',
    'IH': 'iHunt',
    'IK': 'iKoMo',
    'IE': 'iView',
    'IM': 'i-mate',
    'I1': 'iOcean',
    'I2': 'IconBIT',
    'IL': 'IMO Mobile',
    'I7': 'iLA',
    'IW': 'iNew',
    'IP': 'iPro',
    'IF': 'Infinix',
    'I0': 'InFocus',
    'I5': 'InnJoo',
    'IN': 'Innostream',
    'IS': 'Insignia',
    'I4': 'Inoi',
    'IR': 'iRola',
    'I6': 'Irbis',
    'IU': 'iRulu',
    'II': 'Inkti',
    'IX': 'Intex',
    'IO': 'i-mobile',
    'IQ': 'INQ',
    'IT': 'Intek',
    'IV': 'Inverto',
    'I3': 'Impression',
    'IZ': 'iTel',
    'I9': 'iZotron',
    'JA': 'JAY-Tech',
    'JI': 'Jiayu',
    'JO': 'Jolla',
    'J5': 'Just5',
    'KL': 'Kalley',
    'K4': 'Kaan',
    'K7': 'Kaiomy',
    'K6': 'Kanji',
    'KA': 'Karbonn',
    'KD': 'KDDI',
    'K5': 'KATV1',
    'K1': 'Kiano',
    'KI': 'Kingsun',
    'KV': 'Kivi',
    'KC': 'Kocaso',
    'KG': 'Kogan',
    'KO': 'Konka',
    'KM': 'Komu',
    'KB': 'Koobee',
    'KT': 'K-Touch',
    'KH': 'KT-Tech',
    'KK': 'Kodak',
    'KP': 'KOPO',
    'KW': 'Konrow',
    'KR': 'Koridy',
    'K2': 'KRONO',
    'KS': 'Kempler & Strauss',
    'K3': 'Keneksi',
    'KU': 'Kumai',
    'KY': 'Kyocera',
    'KZ': 'Kazam',
    'KE': 'Krüger&Matz',
    'LQ': 'LAIQ',
    'L2': 'Landvo',
    'L6': 'Land Rover',
    'LV': 'Lava',
    'LA': 'Lanix',
    'LK': 'Lark',
    'LC': 'LCT',
    'L5': 'Leagoo',
    'LD': 'Ledstar',
    'L1': 'LeEco',
    'L4': 'Lemhoov',
    'LE': 'Lenovo',
    'LN': 'Lenco',
    'LT': 'Leotec',
    'L7': 'Lephone',
    'LP': 'Le Pan',
    'LG': 'LG',
    'LI': 'Lingwin',
    'LO': 'Loewe',
    'LM': 'Logicom',
    'L3': 'Lexand',
    'LX': 'Lexibook',
    'LY': 'LYF',
    'LU': 'Lumus',
    'L9': 'Luna',
    'MN': 'M4tel',
    'MJ': 'Majestic',
    'MA': 'Manta Multimedia',
    '5M': 'Mann',
    '2M': 'Masstel',
    'MW': 'Maxwest',
    '7M': 'Maxcom',
    'M0': 'Maze',
    'MB': 'Mobistel',
    '0M': 'Mecool',
    'M3': 'Mecer',
    'MD': 'Medion',
    'M2': 'MEEG',
    'M1': 'Meizu',
    '3M': 'Meitu',
    'ME': 'Metz',
    'MX': 'MEU',
    'MI': 'MicroMax',
    'M5': 'MIXC',
    'MH': 'Mobiola',
    '4M': 'Mobicel',
    'M6': 'Mobiistar',
    'MC': 'Mediacom',
    'MK': 'MediaTek',
    'MO': 'Mio',
    'M7': 'Miray',
    'MM': 'Mpman',
    'M4': 'Modecom',
    'MF': 'Mofut',
    'MR': 'Motorola',
    'MV': 'Movic',
    'MS': 'Microsoft',
    'M9': 'MTC',
    'MP': 'MegaFon',
    'MZ': 'MSI',
    'MU': 'Memup',
    'MT': 'Mitsubishi',
    'ML': 'MLLED',
    'MQ': 'M.T.T.',
    'N4': 'MTN',
    'MY': 'MyPhone',
    '1M': 'MYFON',
    'MG': 'MyWigo',
    'M8': 'Myria',
    '6M': 'Mystery',
    'N3': 'Navon',
    'N7': 'National',
    'N5': 'NOA',
    'NE': 'NEC',
    'NF': 'Neffos',
    'NA': 'Netgear',
    'NU': 'NeuImage',
    'NG': 'NGM',
    'N6': 'Nobby',
    'NZ': 'NG Optics',
    'NO': 'Nous',
    'NI': 'Nintendo',
    'N1': 'Noain',
    'N2': 'Nextbit',
    'NK': 'Nokia',
    'NV': 'Nvidia',
    'NB': 'Noblex',
    'NM': 'Nomi',
    'N0': 'Nuvo',
    'NL': 'NUU Mobile',
    'NY': 'NYX Mobile',
    'NN': 'Nikon',
    'NW': 'Newgen',
    'NS': 'NewsMy',
    'NX': 'Nexian',
    'NT': 'NextBook',
    'O3': 'O+',
    'OB': 'Obi',
    'O1': 'Odys',
    'OD': 'Onda',
    'ON': 'OnePlus',
    'OP': 'OPPO',
    'OR': 'Orange',
    'OS': 'Ordissimo',
    'OT': 'O2',
    'OK': 'Ouki',
    'OE': 'Oukitel',
    'OU': 'OUYA',
    'OO': 'Opsson',
    'OV': 'Overmax',
    'OY': 'Oysters',
    'OW': 'öwn',
    'PN': 'Panacom',
    'PA': 'Panasonic',
    'PB': 'PCBOX',
    'PC': 'PCD',
    'PD': 'PCD Argentina',
    'PE': 'PEAQ',
    'PG': 'Pentagram',
    'PH': 'Philips',
    'PI': 'Pioneer',
    'PX': 'Pixus',
    'PL': 'Polaroid',
    'P5': 'Polytron',
    'P9': 'Primepad',
    'P6': 'Proline',
    'PM': 'Palm',
    'PO': 'phoneOne',
    'PT': 'Pantech',
    'PY': 'Ployer',
    'P4': 'Plum',
    'PV': 'Point of View',
    'PP': 'PolyPad',
    'P2': 'Pomp',
    'P3': 'PPTV',
    'PS': 'Positivo',
    'PR': 'Prestigio',
    'P1': 'ProScan',
    'PU': 'PULID',
    'QI': 'Qilive',
    'QT': 'Qtek',
    'QH': 'Q-Touch',
    'QM': 'QMobile',
    'QA': 'Quantum',
    'QU': 'Quechua',
    'QO': 'Qumo',
    'RA': 'Ramos',
    'RC': 'RCA Tablets',
    'RB': 'Readboy',
    'RI': 'Rikomagic',
    'RN': 'Rinno',
    'RV': 'Riviera',
    'RM': 'RIM',
    'RK': 'Roku',
    'RO': 'Rover',
    'R6': 'RoverPad',
    'RR': 'Roadrover',
    'R1': 'Rokit',
    'R3': 'Rombica',
    'RT': 'RT Project',
    'RX': 'Ritmix',
    'R7': 'Ritzviva',
    'R5': 'Ross&Moor',
    'R2': 'R-TV',
    'RG': 'RugGear',
    'RU': 'Runbo',
    'SQ': 'Santin',
    'SA': 'Samsung',
    'S0': 'Sanei',
    'SD': 'Sega',
    'SL': 'Selfix',
    'SE': 'Sony Ericsson',
    'S1': 'Sencor',
    'SF': 'Softbank',
    'SX': 'SFR',
    'SG': 'Sagem',
    'SH': 'Sharp',
    '7S': 'Shift Phones',
    '3S': 'Shuttle',
    'SI': 'Siemens',
    'SJ': 'Silent Circle',
    '1S': 'Sigma',
    'SN': 'Sendo',
    'S6': 'Senseit',
    'EW': 'Senwa',
    'SW': 'Sky',
    'SK': 'Skyworth',
    'SC': 'Smartfren',
    'SO': 'Sony',
    'OI': 'Sonim',
    'SP': 'Spice',
    '6S': 'Spectrum',
    'SU': 'SuperSonic',
    '5S': 'Sunvell',
    'S5': 'Supra',
    'SV': 'Selevision',
    'SY': 'Sanyo',
    'SM': 'Symphony',
    '4S': 'Syrox',
    'SR': 'Smart',
    'S7': 'Smartisan',
    'S4': 'Star',
    'SB': 'STF Mobile',
    'S8': 'STK',
    'S9': 'Savio',
    '2S': 'Starway',
    'ST': 'Storex',
    'S2': 'Stonex',
    'S3': 'SunVan',
    'SZ': 'Sumvision',
    'SS': 'SWISSMOBILITY',
    '10': 'Simbans',
    'X1': 'Safaricom',
    'TA': 'Tesla',
    'T5': 'TB Touch',
    'TC': 'TCL',
    'T7': 'Teclast',
    'TE': 'Telit',
    'T4': 'ThL',
    'TH': 'TiPhone',
    'TB': 'Tecno Mobile',
    'TP': 'TechPad',
    'TD': 'Tesco',
    'TI': 'TIANYU',
    'TG': 'Telego',
    'TL': 'Telefunken',
    'T2': 'Telenor',
    'TM': 'T-Mobile',
    'TN': 'Thomson',
    'TQ': 'Timovi',
    'TY': 'Tooky',
    'T1': 'Tolino',
    'T9': 'Top House',
    'TO': 'Toplux',
    'T8': 'Touchmate',
    'TS': 'Toshiba',
    'TT': 'TechnoTrend',
    'T6': 'TrekStor',
    'T3': 'Trevi',
    'TU': 'Tunisie Telecom',
    'TR': 'Turbo-X',
    '1T': 'Turbo',
    '11': 'True',
    'TV': 'TVC',
    'TX': 'TechniSat',
    'TZ': 'teXet',
    'UC': 'U.S. Cellular',
    'UH': 'Uhappy',
    'UL': 'Ulefone',
    'UG': 'Ugoos',
    'UO': 'Unnecto',
    'UN': 'Unowhy',
    'US': 'Uniscope',
    'UX': 'Unimax',
    'UM': 'UMIDIGI',
    'UU': 'Unonu',
    'UK': 'UTOK',
    'UA': 'Umax',
    'UT': 'UTStarcom',
    'UZ': 'Unihertz',
    'VA': 'Vastking',
    'VD': 'Videocon',
    'VE': 'Vertu',
    'VN': 'Venso',
    'V5': 'Vivax',
    'VI': 'Vitelcom',
    'VK': 'VK Mobile',
    'V7': 'Vinga',
    'VS': 'ViewSonic',
    'V9': 'Vsun',
    'V8': 'Vesta',
    'VT': 'Vestel',
    'VR': 'Vernee',
    'V4': 'Verizon',
    'VL': 'Verykool',
    'V6': 'VGO TEL',
    'VV': 'Vivo',
    'VX': 'Vertex',
    'V3': 'Vinsoc',
    'V2': 'Vonino',
    'VG': 'Vorago',
    'V1': 'Voto',
    'VO': 'Voxtel',
    'VF': 'Vodafone',
    'VZ': 'Vizio',
    'VW': 'Videoweb',
    'VU': 'Vulcan',
    'WA': 'Walton',
    'WF': 'Wileyfox',
    'WN': 'Wink',
    'WM': 'Weimei',
    'WE': 'WellcoM',
    'WY': 'Wexler',
    'WI': 'Wiko',
    'WL': 'Wolder',
    'WP': 'Wieppo',
    'WG': 'Wolfgang',
    'WO': 'Wonu',
    'W1': 'Woo',
    'WX': 'Woxter',
    'XV': 'X-View',
    'XI': 'Xiaomi',
    'XL': 'Xiaolajiao',
    'XN': 'Xion',
    'XO': 'Xolo',
    'YA': 'Yarvik',
    'XR': 'Xoro',
    'Y2': 'Yes',
    'YE': 'Yezz',
    'Y1': 'Yu',
    'YU': 'Yuandao',
    'YS': 'Yusun',
    'YO': 'Yota',
    'YT': 'Ytone',
    'YX': 'Yxtel',
    'ZE': 'Zeemi',
    'ZK': 'Zenek',
    'ZO': 'Zonda',
    'ZP': 'Zopo',
    'ZT': 'ZTE',
    'ZU': 'Zuum',
    'ZN': 'Zen',
    'ZY': 'Zync',
    'ZQ': 'ZYQ',
    'XT': 'X-TIGI',
    'XB': 'NEXBOX',
    # legacy brands, might be removed in future versions
    'WB': 'Web TV',
    'XX': 'Unknown',
}

# flip Abbrev / Brand for fast membership testing
BRAND_TO_ABBREV = {brand.lower(): abbrev for abbrev, brand in DEVICE_BRANDS.items()}


class BaseDeviceParser(Parser):

    DEVICE_NAMES = DEVICE_NAMES

    DEVICE_TYPE_DESKTOP = DEVICE_TYPE_DESKTOP
    DEVICE_TYPE_SMARTPHONE = DEVICE_TYPE_SMARTPHONE
    DEVICE_TYPE_TABLET = DEVICE_TYPE_TABLET
    DEVICE_TYPE_FEATURE_PHONE = DEVICE_TYPE_FEATURE_PHONE
    DEVICE_TYPE_CONSOLE = DEVICE_TYPE_CONSOLE
    DEVICE_TYPE_TV = DEVICE_TYPE_TV
    DEVICE_TYPE_CAR_BROWSER = DEVICE_TYPE_CAR_BROWSER
    DEVICE_TYPE_SMART_DISPLAY = DEVICE_TYPE_SMART_DISPLAY
    DEVICE_TYPE_CAMERA = DEVICE_TYPE_CAMERA
    DEVICE_TYPE_PORTABLE_MEDIA_PAYER = DEVICE_TYPE_PORTABLE_MEDIA_PAYER
    DEVICE_TYPE_PHABLET = DEVICE_TYPE_PHABLET

    DEVICE_TYPES = DEVICE_TYPES

    DEVICE_BRANDS = DEVICE_BRANDS

    BRAND_TO_ABBREV = BRAND_TO_ABBREV


__all__ = (
    'BaseDeviceParser',
    'DEVICE_BRANDS',
    'MOBILE_DEVICE_TYPES',
)
